		NAME	OPTPICK
		PAGE	60,132

;------------------------------------------------------------------;
;                                                                  ;
;  VERSION 1.03  -  OPTPICK.COM                                    ;
;                                                                  ;
;  This program works with CCS.CTL to access the configuration     ;
;  option of CONFIG.SYS selected by the user at boot time.  It     ;
;  can be used in the AUTOEXEC.BAT file so that the corresponding  ;
;  commands for each option can be executed.  See CCS.ASM for      ;
;  more details.                                                   ;
;  OPTPICK opens the file "CCS103XX" (set up by CCS.CTL) to        ;
;  access the option selected by the user at boot time.  It        ;
;  then sets an environment variable CCS103 to the letter option   ;
;  selected by the user during the loading of CONFIG.SYS.          ;
;  Any batch file (usually autoexec.bat) can then access this      ;
;  variable.                                                       ;
;                                                                  ;
;------------------------------------------------------------------;

		.MODEL tiny

MoveString	MACRO
		LOCAL	CX_EVEN
		shr	cx,1
		rep	movsw
		jae	CX_EVEN
		movsb
CX_EVEN:
		ENDM

MoveStringRev	MACRO
		LOCAL	CX_EVEN
		shr	cx,1
		rep	movsw
		inc	di
		inc	si
		jae	CX_EVEN
		movsb
CX_EVEN:
		ENDM

MoveEnvVar	MACRO
		mov	si,offset ccs_var
		mov	cx,CCS_VAR_LEN
		rep	movsb
		ENDM

		.DATA
CR		EQU	13
LF		EQU	10

savebyte	db	0
ccs_var		db	"CCS103="
CCS_VAR_LEN	EQU	$-ccs_var

startup_msg	db	CR,LF,"Version 1.03  OPTPICK.COM",CR,LF
		db	"Freeware Copyright (C) 1991 by Soh Kok Hong",CR,LF
		db	"$"

filename	db	"CCS103XX",0

error_msg1	db	CR,LF,"Error in opening file CCS103XX",CR,LF,"$"

error_msg2	db	CR,LF,"Not enough environment space",CR,LF,"$"

		.CODE
		ORG	100H

start:		mov	dx,offset startup_msg	;print startup message
		call	print_string

		mov	dx,offset filename	;prepare to open file
		mov	ax,3D00H
		int	21h
		jnc	filefound		;if file found, jump.

		mov	dx,offset error_msg1	;file not found
		call	print_string
		mov	al,1
		jmp	done

filefound:	mov	bx,ax			;read byte from file
		mov	cx,1
		mov	dx,offset savebyte
		mov	ah,3fh
		int	21h

		mov	si,16h		;start search for parent PSP segment
		push	ds
find_dospsp:	mov	ax,ds
		mov	bx,[si]
		cmp	ax,bx
		jz	dospsp_found
		mov	ds,bx
		jmp	find_dospsp

dospsp_found:	mov	si,02ch		;find the environment segment
		mov	bx,[si]
		pop	ds

		dec	bx		;get size of environment
		mov	di,3
		mov	es,bx
		mov	ax,es:[di]
		mov	cl,4
		sal	ax,cl
		inc	bx
		mov	es,bx

;check if enough space for new environment variable.
		cld			;find end of environment
		mov	cx,ax
		mov	dx,ax		;store away environment size
		xor	al,al
		xor	di,di

find_env_var:	mov	bx,cx
		mov	si,offset ccs_var
		mov	cx,CCS_VAR_LEN
		repe	cmpsb
		jz	store_env
		add	bx,cx
		sub	bx,CCS_VAR_LEN
		mov	cx,bx
		repne	scasb
		jcxz	no_memory
		cmp	es:[di],al
		jnz	find_env_var

end_env_found:	cmp	cx,CCS_VAR_LEN+2
		jc	no_memory

		push	ds		;adjust tail of environment
		mov	ax,es
		mov	ds,ax
		mov	cx,dx
		sub	cx,CCS_VAR_LEN+2
		sub	cx,di
		mov	di,dx
		sub	di,2
		mov	si,di
		sub	si,CCS_VAR_LEN+2
		std
		MoveStringRev
		pop	ds

		cld
		mov	di,si		;enter new environment
		inc	di
		MoveEnvVar
		mov	al,savebyte
		stosb
		xor	al,al
		stosb
		jmp	done

store_env:	mov	al,savebyte
		stosb
		mov	si,di
		xor	al,al
		scasb
		jz	done
		sub	bx,CCS_VAR_LEN+2
		mov	cx,bx
		repne	scasb
		jnz	no_memory
		dec	di
		xchg	si,di
		push	ds
		mov	bx,es
		mov	ds,bx
		MoveString
		pop	ds
		jmp	done

no_memory:	mov	dx,offset error_msg2
		call	print_string
		mov	al,1
done:		mov	ah,4ch			;return exit code
		int	21h

print_string	proc	near

		mov	ah,09
		int	21h
		ret
print_string	endp

		END start
